| OpendTect 8.0

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Public Attributes | Protected Member Functions | Protected Attributes | Private Member Functions | Static Private Member Functions | Friends | List of all members
visBase::BoxDragger Class Reference
visBase

`#include <visboxdragger.h>`

Inheritance diagram for visBase::BoxDragger:
[legend]

## Public Member Functions
Coord3 | center () const
const char * | getClassName () const override
const visBase::Transformation * | getDisplayTransformation () const override
int | getPlaneTransDragKeys (bool depth) const
bool | isDraggerBorderShown () const
bool | isInDepthTranslationUsedForResize () const
bool | selectable () const override
void | setBoxTransparency (float)
| Between 0 and 1.
void | setCenter (const Coord3 &)
void | setDisplayTransformation (const visBase::Transformation *) override
void | setDragCtrlSpacing (const StepInterval< float > &, const StepInterval< float > &, const StepInterval< float > &)
void | setPlaneTransDragKeys (bool depth, int keys)
void | setSelectable (bool yn)
void | setSpaceLimits (const Interval< float > &, const Interval< float > &, const Interval< float > &)
void | setWidth (const Coord3 &)
void | setWidthLimits (const Interval< float > &x, const Interval< float > &y, const Interval< float > &z)
void | showDraggerBorder (bool yn=true)
void | showScaleTabs (bool)
void | useInDepthTranslationForResize (bool)
Coord3 | width () const
Public Member Functions inherited from visBase::VisualObjectImpl
virtual void | fillPar (IOPar &) const
const Material * | getMaterial () const
Material * | getMaterial () override
bool | isRightHandSystem () const override
NotifierAccess * | materialChange ()
void | readLock ()
void | readUnLock ()
void | setLockable ()
void | setMaterial (Material *) override
void | setRightHandSystem (bool yn) override
bool | tryReadLock ()
bool | tryWriteLock ()
virtual bool | usePar (const IOPar &)
void | writeLock ()
void | writeUnLock ()
Public Member Functions inherited from visBase::VisualObject
NotifierAccess * | deSelection () override
virtual bool | getBoundingBox (Coord3 &min, Coord3 &max) const
NotifierAccess * | rightClicked () override
const EventInfo * | rightClickedEventInfo () const
const TypeSet< VisID > * | rightClickedPath () const override
bool | selectable () const override
NotifierAccess * | selection () override
virtual void | setSceneEventCatcher (EventCatcher *)
void | setSelectable (bool yn)
Public Member Functions inherited from visBase::DataObject
template<class T >
T * | addNodeState (T *ns)
void | deSelect () const
void | enableTraversal (unsigned int mask, bool yn=true)
virtual const char * | errMsg () const
SoNode * | getInventorNode ()
const SoNode * | getInventorNode () const
BufferString | getName () const override
NodeState * | getNodeState (int idx)
virtual float | getPixelDensity () const
VisID | id () const
virtual bool | isOK () const
virtual bool | isOn () const
bool | isPickable (bool actively=true) const
virtual bool | isSelected () const
bool | isTraversalEnabled (unsigned int mask) const
const OD::String & | name () const override
osg::Node * | osgNode (bool skipswitch=false)
const osg::Node * | osgNode (bool skipswitch=false) const
NodeState * | removeNodeState (NodeState *)
virtual bool | rightClickable () const
void | select () const
bool | serialize (const char *filename, bool binary=false)
void | setID (const VisID &)
void | setName (const char *) override
void | setName (const uiString &uistr)
void | setPickable (bool actively, bool passively=true)
virtual void | setPixelDensity (float dpi)
void | setUiName (const uiString &)
virtual bool | turnOn (bool yn)
uiString | uiName () const
void | updateSel () const
Public Member Functions inherited from SharedObject
| SharedObject (const char *nm=nullptr)
Public Member Functions inherited from NamedCallBacker
| NamedCallBacker (const char *nm=nullptr)
| NamedCallBacker (const NamedCallBacker &)=delete
| ~NamedCallBacker ()
virtual Notifier< NamedCallBacker > & | objectToBeDeleted () const
NamedCallBacker & | operator= (const NamedCallBacker &)=delete
bool | operator== (const NamedCallBacker &oth) const
bool | operator== (const NamedObject &oth) const
Public Member Functions inherited from CallBacker
| CallBacker ()
| CallBacker (const CallBacker &)
virtual | ~CallBacker ()
bool | attachCB (const NotifierAccess &, const CallBack &, bool onlyifnew=false) const
bool | attachCB (const NotifierAccess *notif, const CallBack &cb, bool onlyifnew=false) const
void | detachAllNotifiers () const
| Call from the destructor of your inherited object.
void | detachCB (const NotifierAccess &, const CallBack &) const
void | detachCB (const NotifierAccess *notif, const CallBack &cb) const
virtual bool | isCapsule () const
bool | isNotifierAttached (const NotifierAccess *) const
| Only for debugging purposes, don't use.
CallBacker & | operator= (const CallBacker &)=delete
void | stopReceivingNotifications () const
virtual CallBacker * | trueCaller ()
Public Member Functions inherited from NamedObject
| NamedObject (const char *nm=nullptr)
| NamedObject (const NamedObject &oth)
virtual | ~NamedObject ()
bool | getNameFromPar (const IOPar &)
const name_type & | name () const override
NamedObject & | operator= (const NamedObject &)
bool | operator== (const NamedObject &oth) const
Public Member Functions inherited from ObjectWithName
virtual | ~ObjectWithName ()
bool | hasName (const char *nm) const
bool | hasName (const name_type &nm) const
void | putNameInPar (IOPar &) const
Public Member Functions inherited from RefCount::Referenced
void | addObserver (WeakPtrBase *obs)
| Not for normal use. May become private.
int | nrRefs () const
| Only for expert use.
void | ref () const
bool | refIfReffed () const
| Don't use in production, for debugging.
void | removeObserver (WeakPtrBase *obs)
| Not for normal use. May become private.
bool | tryRef () const
| Not for normal use. May become private.
void | unRef () const
void | unRefNoDelete () const

## Static Public Member Functions
static RefMan< BoxDragger > | create ()
static const char * | getStaticClassName ()
static void | initClass ()
static const char * | sFactoryKeyword ()
Static Public Member Functions inherited from visBase::VisualObjectImpl
static const char * | sKeyIsOn ()
static const char * | sKeyMaterial ()
static const char * | sKeyMaterialID ()
Static Public Member Functions inherited from visBase::DataObject
static osgViewer::CompositeViewer * | getCommonViewer ()
static float | getDefaultPixelDensity ()
static VisID | getID (const osg::Node *)
static bool | isVisualizationThread ()
static void | requestSingleRedraw ()
static void | setCommonViewer (osgViewer::CompositeViewer *)
static void | setDefaultPixelDensity (float)
static void | setVisualizationThread (const void *)
| Call only once from initialization.
Static Public Member Functions inherited from SharedObject
static Notifier< SharedObject > & | instanceCreated ()
Static Public Member Functions inherited from CallBacker
static void | createReceiverForCurrentThread ()
static void | removeReceiverForCurrentThread ()
Static Public Member Functions inherited from RefCount::Referenced
static bool | isSane (const Referenced *)

## Public Attributes
Notifier< BoxDragger > | changed
Notifier< BoxDragger > | finished
Notifier< BoxDragger > | motion
Notifier< BoxDragger > | started

## Protected Member Functions
| ~BoxDragger ()
void | setOsgMatrix (const Coord3 &worldscale, const Coord3 &worldtrans)
Protected Member Functions inherited from visBase::VisualObjectImpl
| VisualObjectImpl (bool selectable)
virtual | ~VisualObjectImpl ()
int | addChild (osg::Node *)
int | childIndex (const osg::Node *) const
void | insertChild (int pos, osg::Node *)
virtual void | materialChangeCB (CallBacker *)
void | removeChild (osg::Node *)
void | setGroupNode (DataObject *)
virtual void | setGroupNode (osg::Group *)
| Must be called during construction.
Protected Member Functions inherited from visBase::VisualObject
| VisualObject (bool selectable=false)
| ~VisualObject ()
void | triggerDeSel () override
void | triggerRightClick (const EventInfo *) override
void | triggerSel () override
Protected Member Functions inherited from visBase::DataObject
| DataObject ()
| ~DataObject ()
void | doAddNodeState (NodeState *)
virtual osg::StateSet * | getStateSet ()
template<class T >
T * | setOsgNode (T *t)
| Must be called during construction.
void | updateNodemask ()
Protected Member Functions inherited from SharedObject
| ~SharedObject ()
Protected Member Functions inherited from NamedCallBacker
void | sendDelNotif () const
Protected Member Functions inherited from RefCount::Referenced
| Referenced ()
| Referenced (const Referenced &)
virtual | ~Referenced ()
Referenced & | operator= (const Referenced &)

## Protected Attributes
StepInterval< float > | dragctrlspacing_ [3]
osgGeo::TabBoxDragger * | osgboxdragger_
BoxDraggerCallbackHandler * | osgcallbackhandler_ = nullptr
osg::ShapeDrawable * | osgdraggerbox_
bool | selectable_
Interval< float > | spaceranges_ [3]
ConstRefMan< visBase::Transformation > | transform_
bool | useindepthtransforresize_ = false
Interval< float > | widthranges_ [3]
Protected Attributes inherited from visBase::VisualObjectImpl
RefMan< Material > | material_
bool | righthandsystem_ = true
Protected Attributes inherited from NamedCallBacker
Threads::Atomic< bool > | delalreadytriggered_
Notifier< NamedCallBacker > | delnotif_
Protected Attributes inherited from NamedObject
BufferString | name_

## Private Member Functions
| BoxDragger ()
| mOD_DisableCopy (BoxDragger)

## Static Private Member Functions
static visBase::DataObject * | createInternal ()

## Friends
class | BoxDraggerCallbackHandler

## Additional Inherited Members
Public Types inherited from ObjectWithName
typedef OD::String | name_type

## Detailed Description

<>

## Constructor & Destructor Documentation

## ◆ BoxDragger()

visBase::BoxDragger::BoxDragger | ( |  | ) |
| private

## ◆ ~BoxDragger()

visBase::BoxDragger::~BoxDragger | ( |  | ) |
| protected

## Member Function Documentation

## ◆ center()

Coord3 visBase::BoxDragger::center | ( |  | ) | const

## ◆ create()

static RefMan< BoxDragger > visBase::BoxDragger::create | ( |  | ) |
| static

## ◆ createInternal()

static visBase::DataObject * visBase::BoxDragger::createInternal | ( |  | ) |
| inline static private

## ◆ getClassName()

const char * visBase::BoxDragger::getClassName | ( |  | ) | const
| override virtual

Reimplemented from visBase::DataObject.

## ◆ getDisplayTransformation()

const visBase::Transformation * visBase::BoxDragger::getDisplayTransformation | ( |  | ) | const
| override virtual

All positions going from the outside world to the vis should be transformed with this transform. This enables us to have different coord-systems outside OI, e.g. we can use UTM coords outside the vis without loosing precision in the vis.

Reimplemented from visBase::DataObject.

## ◆ getPlaneTransDragKeys()

int visBase::BoxDragger::getPlaneTransDragKeys | ( | bool | depth | ) | const

Parameters

  depth | tells whether the setting for in-depth or in-plane translation of the box should be returned.

Returns
  combination of OD::ButtonState

## ◆ getStaticClassName()

static const char * visBase::BoxDragger::getStaticClassName | ( |  | ) |
| static

## ◆ initClass()

static void visBase::BoxDragger::initClass | ( |  | ) |
| static

## ◆ isDraggerBorderShown()

bool visBase::BoxDragger::isDraggerBorderShown | ( |  | ) | const

## ◆ isInDepthTranslationUsedForResize()

bool visBase::BoxDragger::isInDepthTranslationUsedForResize | ( |  | ) | const

## ◆ mOD_DisableCopy()

visBase::BoxDragger::mOD_DisableCopy | ( | BoxDragger |  | ) |
| private

## ◆ selectable()

bool visBase::BoxDragger::selectable | ( |  | ) | const
| inline override virtual

Reimplemented from visBase::DataObject.

## ◆ setBoxTransparency()

void visBase::BoxDragger::setBoxTransparency | ( | float |  | ) |

Between 0 and 1.

## ◆ setCenter()

void visBase::BoxDragger::setCenter | ( | const Coord3 & |  | ) |

## ◆ setDisplayTransformation()

void visBase::BoxDragger::setDisplayTransformation | ( | const visBase::Transformation * |  | ) |
| override virtual

All positions going from the outside world to the vis should be transformed with this transform. This enables us to have different coord-systems outside OI, e.g. we can use UTM coords outside the vis without loosing precision in the vis.

Reimplemented from visBase::DataObject.

## ◆ setDragCtrlSpacing()

void visBase::BoxDragger::setDragCtrlSpacing | ( | const StepInterval< float > & | ,
|  | const StepInterval< float > & | ,
|  | const StepInterval< float > & | )

## ◆ setOsgMatrix()

void visBase::BoxDragger::setOsgMatrix | ( | const Coord3 & | worldscale,
|  | const Coord3 & | worldtrans )
| protected

## ◆ setPlaneTransDragKeys()

void visBase::BoxDragger::setPlaneTransDragKeys | ( | bool | depth,
|  | int | keys )

Parameters

  depth | tells whether the setting for in-depth or in-plane translation of the box planes should be changed.
  keys | combination of OD::ButtonState

Note
  only shift/ctrl/alt are used.

## ◆ setSelectable()

void visBase::BoxDragger::setSelectable | ( | bool | yn | ) |
| inline

## ◆ setSpaceLimits()

void visBase::BoxDragger::setSpaceLimits | ( | const Interval< float > & | ,
|  | const Interval< float > & | ,
|  | const Interval< float > & | )

## ◆ setWidth()

void visBase::BoxDragger::setWidth | ( | const Coord3 & |  | ) |

## ◆ setWidthLimits()

void visBase::BoxDragger::setWidthLimits | ( | const Interval< float > & | x,
|  | const Interval< float > & | y,
|  | const Interval< float > & | z )

## ◆ sFactoryKeyword()

static const char * visBase::BoxDragger::sFactoryKeyword | ( |  | ) |
| static

## ◆ showDraggerBorder()

void visBase::BoxDragger::showDraggerBorder | ( | bool | yn = true | ) |

## ◆ showScaleTabs()

void visBase::BoxDragger::showScaleTabs | ( | bool |  | ) |

## ◆ useInDepthTranslationForResize()

void visBase::BoxDragger::useInDepthTranslationForResize | ( | bool |  | ) |

## ◆ width()

Coord3 visBase::BoxDragger::width | ( |  | ) | const

## Friends And Related Symbol Documentation

## ◆ BoxDraggerCallbackHandler

friend class BoxDraggerCallbackHandler
| friend

## Member Data Documentation

## ◆ changed

Notifier<BoxDragger> visBase::BoxDragger::changed

## ◆ dragctrlspacing_

StepInterval<float> visBase::BoxDragger::dragctrlspacing_[3]
| protected

## ◆ finished

Notifier<BoxDragger> visBase::BoxDragger::finished

## ◆ motion

Notifier<BoxDragger> visBase::BoxDragger::motion

## ◆ osgboxdragger_

osgGeo::TabBoxDragger* visBase::BoxDragger::osgboxdragger_
| protected

## ◆ osgcallbackhandler_

BoxDraggerCallbackHandler* visBase::BoxDragger::osgcallbackhandler_ = nullptr
| protected

## ◆ osgdraggerbox_

osg::ShapeDrawable* visBase::BoxDragger::osgdraggerbox_
| protected

## ◆ selectable_

bool visBase::BoxDragger::selectable_
| protected

## ◆ spaceranges_

Interval<float> visBase::BoxDragger::spaceranges_[3]
| protected

## ◆ started

Notifier<BoxDragger> visBase::BoxDragger::started

## ◆ transform_

ConstRefMan< visBase::Transformation > visBase::BoxDragger::transform_
| protected

## ◆ useindepthtransforresize_

bool visBase::BoxDragger::useindepthtransforresize_ = false
| protected

## ◆ widthranges_

Interval<float> visBase::BoxDragger::widthranges_[3]
| protected

Generated at
for the OpendTect seismic interpretation project. Copyright (C): dGB Beheer B.V. 1995-2025